'
'  BASS.DLL RapidQ INCLUDE FILE
'      DLL version 1.8 only
'
'       By Baptiste BIDEAUX
'        zecreator@yahoo.fr
'
Const BASS_OK = 0               'all is OK
Const BASS_ERROR_MEM = 1        'memory error
Const BASS_ERROR_FILEOPEN = 2   'can't open the file
Const BASS_ERROR_DRIVER = 3     'can't find a free sound driver
Const BASS_ERROR_BUFLOST = 4    'the sample buffer was lost
Const BASS_ERROR_HANDLE = 5     'invalid handle
Const BASS_ERROR_FORMAT = 6     'unsupported sample format
Const BASS_ERROR_POSITION = 7   'invalid playback position
Const BASS_ERROR_INIT = 8       'BASS_Init has not been successfully called
Const BASS_ERROR_START = 9      'BASS_Start has not been successfully called
Const BASS_ERROR_INITCD = 10    'can't initialize CD
Const BASS_ERROR_CDINIT = 11    'BASS_CDInit has not been successfully called
Const BASS_ERROR_NOCD = 12      'no CD in drive
Const BASS_ERROR_CDTRACK = 13   'can't play the selected CD track
Const BASS_ERROR_ALREADY = 14   'already initialized
Const BASS_ERROR_CDVOL = 15     'CD has no volume control
Const BASS_ERROR_NOPAUSE = 16   'not paused
Const BASS_ERROR_NOTAUDIO = 17  'not an audio track
Const BASS_ERROR_NOCHAN = 18    'can't get a free channel
Const BASS_ERROR_ILLTYPE = 19   'an illegal type was specified
Const BASS_ERROR_ILLPARAM = 20  'an illegal parameter was specified
Const BASS_ERROR_NO3D = 21      'no 3D support
Const BASS_ERROR_NOEAX = 22     'no EAX support
Const BASS_ERROR_DEVICE = 23    'illegal device number
Const BASS_ERROR_NOPLAY = 24    'not playing
Const BASS_ERROR_FREQ = 25      'illegal sample rate
Const BASS_ERROR_NOTFILE = 27   'the stream is not a file stream
Const BASS_ERROR_NOHW = 29      'no hardware voices available
Const BASS_ERROR_EMPTY = 31     'the MOD music has no sequence data
Const BASS_ERROR_NONET = 32     'no internet connection could be opened
Const BASS_ERROR_CREATE = 33    'couldn't create the file
Const BASS_ERROR_NOFX = 34      'effects are not available
Const BASS_ERROR_PLAYING = 35   'the channel is playing
Const BASS_ERROR_NOTAVAIL = 37  'requested data is not available
Const BASS_ERROR_DECODE = 38    'the channel is a "decoding channel"
Const BASS_ERROR_DX = 39        'a sufficient DirectX version is not installed
Const BASS_ERROR_TIMEOUT = 40   'connection timedout
Const BASS_ERROR_FILEFORM = 41  'unsupported file format
Const BASS_ERROR_SPEAKER = 42   'unavailable speaker
Const BASS_ERROR_UNKNOWN = -1   'some other mystery error

Type BASS_SAMPLE
    freq as long
    volume as long
    pan as byte
    flags as long
    length as long
    max as long
    mode3d as long
    mindist as integer
    maxdist as integer
    iangle as long
    oangle as long
    outvol as long
    vam as long
    priority as long
End Type

Const BASS_MUSIC_RAMP = 1       ' normal ramping
Const BASS_MUSIC_RAMPS = 2      ' sensitive ramping
Const BASS_MUSIC_LOOP = 4       ' loop music
Const BASS_MUSIC_FT2MOD = 16    ' play .MOD as FastTracker 2 does
Const BASS_MUSIC_PT1MOD = 32    ' play .MOD as ProTracker 1 does
Const BASS_MUSIC_MONO = 64      ' force mono mixing (less CPU usage)
Const BASS_MUSIC_3D = 128       ' enable 3D functionality
Const BASS_MUSIC_POSRESET = 256 ' stop all notes when moving position
Const BASS_MUSIC_SURROUND = 512 'surround sound
Const BASS_MUSIC_SURROUND2 = 1024 'surround sound (mode 2)
Const BASS_MUSIC_STOPBACK = 2048 'stop the music on a backwards jump effect
Const BASS_MUSIC_FX = 4096      'enable old implementation of DX8 effects
Const BASS_MUSIC_CALCLEN = 8192 'calculate playback length
Const BASS_MUSIC_NONINTER = 16384 ' non-interpolated mixing
Const BASS_MUSIC_FLOAT = &H10000	'32-bit floating-point
Const BASS_MUSIC_DECODE = &H200000 'don't play the music, only decode (BASS_ChannelGetData)
Const BASS_MUSIC_NOSAMPLE = &H400000 ' don't load the samples

Const BASS_SAMPLE_8BITS = 1          ' 8 bit
Const BASS_SAMPLE_FLOAT = 256        ' 32-bit floating-point
Const BASS_SAMPLE_MONO = 2           ' mono, else stereo
Const BASS_SAMPLE_LOOP = 4           ' looped
Const BASS_SAMPLE_3D = 8             ' 3D functionality enabled
Const BASS_SAMPLE_SOFTWARE = 16      ' it's NOT using hardware mixing
Const BASS_SAMPLE_MUTEMAX = 32       ' muted at max distance (3D only)
Const BASS_SAMPLE_VAM = 64           ' uses the DX7 voice allocation & management
Const BASS_SAMPLE_FX = 128           ' old implementation of DX8 effects are enabled
Const BASS_SAMPLE_OVER_VOL = 65536   ' override lowest volume
Const BASS_SAMPLE_OVER_POS = 131072  ' override longest playing
Const BASS_SAMPLE_OVER_DIST = 196608 ' override furthest from listener (3D only)

Const BASS_MP3_SETPOS = 131072       ' enable pin-point seeking on the MP3/MP2/MP1
Const BASS_STREAM_AUTOFREE = 262144  ' automatically free the stream when it stop/ends
Const BASS_STREAM_RESTRATE = 524288  ' restrict the download rate of internet file streams
Const BASS_STREAM_BLOCK = 1048576    ' download/play internet file stream (MPx/OGG) in small blocks
Const BASS_STREAM_DECODE = &H200000  ' don't play the stream, only decode (BASS_ChannelGetData)
Const BASS_STREAM_META = &H400000    ' request metadata from a Shoutcast stream
Const BASS_STREAM_FILEPROC = &H800000 ' use a STREAMFILEPROC callback

Const BASS_SPEAKER_FRONT = &H1000000 ' front speakers
Const BASS_SPEAKER_REAR = &H2000000  ' rear/side speakers
Const BASS_SPEAKER_CENLFE = &H3000000 ' center & LFE speakers (5.1)
Const BASS_SPEAKER_REAR2 = &H4000000 ' rear center speakers (7.1)
Const BASS_SPEAKER_LEFT = &H10000000 ' modifier: left
Const BASS_SPEAKER_RIGHT = &H20000000 ' modifier: right
Const BASS_SPEAKER_FRONTLEFT = BASS_SPEAKER_FRONT or BASS_SPEAKER_LEFT
Const BASS_SPEAKER_FRONTRIGHT = BASS_SPEAKER_FRONT or BASS_SPEAKER_RIGHT
Const BASS_SPEAKER_REARLEFT = BASS_SPEAKER_REAR or BASS_SPEAKER_LEFT
Const BASS_SPEAKER_REARRIGHT = BASS_SPEAKER_REAR or BASS_SPEAKER_RIGHT
Const BASS_SPEAKER_CENTER = BASS_SPEAKER_CENLFE or BASS_SPEAKER_LEFT
Const BASS_SPEAKER_LFE = BASS_SPEAKER_CENLFE or BASS_SPEAKER_RIGHT
Const BASS_SPEAKER_REAR2LEFT = BASS_SPEAKER_REAR2 or BASS_SPEAKER_LEFT
Const BASS_SPEAKER_REAR2RIGHT = BASS_SPEAKER_REAR2 or BASS_SPEAKER_RIGHT

Const BASS_TAG_ID3 = 0   'ID3v1 tags : 128 byte block
Const BASS_TAG_ID3V2 = 1 'ID3v2 tags : variable length block
Const BASS_TAG_OGG = 2   'OGG comments : array of null-terminated strings
Const BASS_TAG_HTTP = 3  'HTTP headers : array of null-terminated strings
Const BASS_TAG_ICY = 4   'ICY headers : array of null-terminated strings
Const BASS_TAG_META = 5  'ICY metadata : nu

' BASS_ChannelIsActive return values
Const BASS_ACTIVE_STOPPED = 0
Const BASS_ACTIVE_PLAYING = 1
Const BASS_ACTIVE_STALLED = 2
Const BASS_ACTIVE_PAUSED = 3

' API Windows
Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" (nDrive As String) As Long


'General
Declare Function BASS_Init lib "bass.dll" Alias "BASS_Init" (device as integer, freq as long, flags as long, winDC as long) as integer
Declare Function BASS_Start lib "bass.dll" Alias "BASS_Start" () as integer
Declare Function BASS_Stop lib "bass.dll" Alias "BASS_Stop" () as integer
Declare Function BASS_Free lib "bass.dll" Alias "BASS_Free" () as integer
Declare Sub BASS_SetVolume lib "bass.dll" Alias "BASS_SetVolume" (musvol as long, smpvol as long, strvol as long)
Declare Function BASS_ErrorGetCode lib "bass.dll" Alias "BASS_ErrorGetCode" () as long
Declare Function BASS_GetVersion lib "bass.dll" Alias "BASS_GetVersion" () as long

'Channels
Declare Function BASS_ChannelStop lib "bass.dll" Alias "BASS_ChannelStop" (HDC as long) as integer
Declare Function BASS_ChannelGetPosition lib "bass.dll" Alias "BASS_ChannelGetPosition" (HDC as long) as long
Declare Function BASS_ChannelSetPosition lib "bass.dll" Alias "BASS_ChannelSetPosition" (HDC as long,pos as long) as long
Declare Function BASS_ChannelActive lib "bass.dll" Alias "BASS_ChannelActive" (HDC as long) as long
Declare Function BASS_ChannelBytes2Seconds lib "bass.dll" Alias "BASS_ChannelBytes2Seconds" (HDC as long,pos as long) as long
Declare Function BASS_ChannelSeconds2Bytes lib "bass.dll" Alias "BASS_ChannelSeconds2Bytes" (HDC as long,pos as long) as integer

'Mp3/Stream
Declare Function BASS_StreamCreateFile lib "bass.dll" Alias "BASS_StreamCreateFile" (mem as integer,file as string, offset as long, length as long, flags as long) as long
Declare Function BASS_StreamPlay lib "bass.dll" Alias "BASS_StreamPlay" (HDC as long,flush as integer,flags as long) as integer
Declare Function BASS_StreamFree lib "bass.dll" Alias "BASS_StreamFree" (HDC as long) as integer
Declare Function BASS_StreamGetLength lib "bass.dll" Alias "BASS_StreamGetLength" (HDC as long) as long
Declare Function BASS_StreamGetTags lib "bass.dll" Alias "BASS_StreamGetTags" (HDC as long,tag as long) as string

'Samples
Declare Function BASS_SampleLoad lib "bass.dll" Alias "BASS_SampleLoad" (mem as integer, file as string,offset as long,length as long, max as long, flags as long) as long
Declare Function BASS_SamplePlayEx lib "bass.dll" Alias "BASS_SamplePlayEx" (HSAMPLE as long, start as long, freq as long, volume as long, pan as long, flag as integer)as long
Declare Function BASS_SampleStop lib "bass.dll" Alias "BASS_SampleStop" (HDC as long) as integer
Declare Function BASS_SampleFree lib "bass.dll" Alias "BASS_SampleFree" (HDC as long) as integer
Declare Function BASS_SampleGetInfo lib "bass.dll" Alias "BASS_SampleGetInfo" (HDC as Long,Info as BASS_SAMPLE) as integer
Declare Function BASS_SampleSetInfo lib "bass.dll" Alias "BASS_SampleSetInfo" (HDC as Long,Info as BASS_SAMPLE) as integer

'Modules
Declare Function BASS_MusicLoad lib "bass.dll" Alias "BASS_MusicLoad" (mem as integer, file as string,offset as long,length as long, flags as long) as long
Declare Function BASS_MusicPlayEx lib "bass.dll" Alias "BASS_MusicPlayEx" (HMOD as long, pos as long,flag as long,reset as integer)as integer
Declare Function BASS_MusicFree lib "bass.dll" Alias "BASS_MusicFree" (HMOD as long) as integer
Declare Function BASS_MusicGetLength lib "bass.dll" Alias "BASS_MusicGetLength" (HDC as long,ord as integer) as long
Declare Function BASS_MusicGetName lib "bass.dll" Alias "BASS_MusicGetName" (HDC as long) as string

'CD
Declare Function BASS_CDInit lib "bass.dll" Alias "BASS_CDInit" (drv as string,flag as long) as integer
Declare Function BASS_CDDoor lib "bass.dll" Alias "BASS_CDDoor" (Stat as integer) as integer
Declare Sub BASS_CDFree lib "bass.dll" Alias "BASS_CDFree" ()
Declare Function BASS_CDGetTracks lib "bass.dll" Alias "BASS_CDGetTracks" as long
Declare Function BASS_CDGetTrackLength lib "bass.dll" Alias "BASS_CDGetTrackLenght" (track as long) as long
Declare Function BASS_CDInDrive lib "bass.dll" Alias "BASS_CDInDrive" as integer
Declare Function BASS_CDPlay lib "bass.dll" Alias "BASS_CDPlay" (track as long,loopmode as integer,flag as integer) as long
Declare Function BASS_CDGetID lib "bass.dll" Alias "BASS_CDGetID" (id as long) as string

' **************************
'         RQ Functions
' **************************

'*********************************
'     Functions Declarations
'*********************************
'BASS functions
Declare Function GetDLLVersion() as String
Declare Function GetLoWord(lparam as long) as Long
Declare Function GetHiWord(lparam as long) as Long
Declare Function InitBass(freq as long,HDC as long)as integer
Declare sub CloseBASS

'Modules functions
Declare Function LoadModule(modfile as string) as long
Declare Sub PlayModule(HDC as long,loopmode as integer)
Declare Function GetModuleLength(HDC as long) as long
Declare Function GetModulePosition(HDC as long) as long
Declare Sub SetModuleVolume(vol as long)
Declare sub ModuleClose(HDC as long)
Declare Function ModuleTitle(HDC as long) as string

'MP3
declare Function LoadMP3(mp3file as string) as long
declare sub PlayMP3(HDC as long, loopmode as integer)
declare Sub SetMP3Volume(vol as long)
Declare sub MP3Close(HDC as long)
Declare Function GetMP3Length(HDC as long) as long
Declare Function GetMP3Position(HDC as long) as long
Declare Function GetMP3Tag(hdc as long) as string
Declare sub SetMP3Position(HDC as long,npos as long)

'Samples
Declare Function LoadSample(Smpfile as string) as long
Declare Sub PlaySample(HDC as long,freq as long, vol as long,pan as long,loopmode as integer)
Declare Sub StopSample(HDC as long)
Declare Sub CloseSample(HDC as long)
Declare Sub SetVolumeSample(vol as integer)

'CD
Declare sub CDInit(drv as string)
Declare Sub CDDoor(mode as integer)
Declare Function CDReady() as integer
Declare Function TrackCount() as long
Declare Function TrackLength(track as long) as long
Declare Function PlayTrack(track as long,loopmode as integer) as long
Declare Function GetCDInfo(id as long) as string
Declare Function GetCDTrackPosition() as long

'General
Declare sub StopPlaying(HDC as long)
Declare Function IsPlaying(HDC as long) as integer
Declare Function IsCDDrive(drv as string) as integer

'************************************
'          Functions Codes
'************************************
Function GetLoWord(lparam As Long) As Long
    ' This is the LOWORD of the lParam:
    GetLoWord = lparam AND &HFFFF
End Function

Function GetHiWord(lparam As Long) As Long
    ' This is the HIWORD of the lParam:
    GetHiWord = lparam\&H10000 AND &HFFFF
End Function

Function GetDLLVersion() As String
    'This function will return the string version
    'of the BASS DLL. Version must be 1.8
    GetDLLVersion=str$(GetLoWord(BASS_GetVersion)) & "." & str$(GetHiWord(BASS_GetVersion))
End Function

Function LoadModule(modfile as string) as long
'
' Load a Module File
' modfile must be a MOD, XM, S3M, IT, MO3, MTM or UMX file.
'
LoadModule=BASS_MusicLoad(false,modfile,0,0,BASS_MUSIC_CALCLEN)
end function

Function ModuleTItle(HDC as long) as string
'
' Return the Module Title
' HDC is the Module Handle Returned by the LoadModule Function.
'
ModuleTitle=BASS_MusicGetName(HDC)
end function

Sub PlayModule(HDC as long,loopmode as integer)
'
' Play module
' HDC is module Handle returned by the LoadModule Function
' loopmode must be TRUE or FALSE
if loopmode=true then
	BASS_MusicPlayEx HDC,0,BASS_MUSIC_LOOP,True
else
	BASS_MusicPlayEx HDC,0,BASS_MUSIC_CALCLEN,True
end if
end sub

Function InitBass(freq as long,HDC as long) as integer
'
' Initialize the BASS System
' freq is the frequency of playrate (8000,11000,22000,44000...)
' HDC is the Qform Handle using the Bass.dll
' return -1 if the DLL version is not 1.8
'
if GetDLLVersion<>"1.8" then
	messagedlg "Bad version of the BASS.DLL. v1.8 waiting...",0,0,0
	InitBass=-1
	end
	exit function
end if

BASS_Init -1,freq,0,HDC
BASS_Start
InitBass=0
end function

Sub StopPlaying(HDC as long)
'
' Stop the module, MP3 or CD track playing
' HDC is the Handle returned by
' the LoadModule or LoadMp3 Functions
'

BASS_ChannelStop HDC
end sub

function GetModulePosition(HDC as long) as long
'
' Return the track number position in progress
' HDC is the Handle returned by LoadModule Function

GetModulePosition=GetLOWord(BASS_ChannelGetPosition(HDC))
end function

function GetModuleLength(HDC as long) as long
'
' Return the length of module in patterns
' HDC is the Handle returned by the LoadModule Function

GetModuleLength=BASS_MusicGetLength(HDC,false)
end function

Sub SetModuleVolume(vol as long)
'
' Set the volume of the all loaded Modules
' vol is the volume value (0 (mute)- 100(default))
'
BASS_SetVolume vol,-1,-1
end sub

sub ModuleClose(HDC as long)
'
' Close a loaded module and free the BASS resource
' HDC is the Handle returned by the LoadModule Function
'
BASS_MusicFree HDC
end sub

sub CloseBASS()
'
' Close the BASS System
'
BASS_Stop
BASS_Free
end sub

Function LoadMP3(mp3file as string) as long
'
' Load a Mp3 file
' return the Mp3 handle
'
LoadMP3=BASS_StreamCreateFile(false,mp3file,0,0,0)
end function

sub PlayMP3(HDC as long, loopmode as integer)
'
' Play a MP3 file
' HDC is the MP3 handle returned by the LoadMP3 function
' loopmode must be True or False
'
if loopmode=true then
	BASS_StreamPlay HDC,0,BASS_MUSIC_LOOP
else
	BASS_StreamPlay HDC,0,BASS_MUSIC_CALCLEN
end if
end sub

Sub SetMP3Volume(vol as long)
'
' Set the volume of the all loaded MP3
' vol is the volume value (0 (mute)- 100(default))
'
BASS_SetVolume -1,-1,vol
end sub

sub MP3Close(HDC as long)
'
' Close a loaded MP3 and free the BASS resource
' HDC is the Handle returned by the LoadMP3 Function
'
BASS_StreamFree HDC
end sub

function GetMP3Position(HDC as long) as long
'
' Return the position in progress
' HDC is the Handle returned by LoadMP3 Function

GetMp3Position=BASS_ChannelGetPosition(HDC)
end function

function GetMP3Length(HDC as long) as long
'
' Return the length of MP3 in bytes
' HDC is the Handle returned by the LoadMP3 Function

GetMP3Length=BASS_StreamGetLength(HDC)
end function

function IsPlaying(HDC as long) as integer
'
'Return TRUE if the BASS Object id playing
'HDC if a Module or MP3 handle
'Return:
' BASS_ACTIVE_STOPPED (0)
' BASS_ACTIVE_PLAYING (1)
' BASS_ACTIVE_PAUSED (2)
' BASS_ACTIVE_STALLED (3, not using here)

IsPlaying=BASS_ChannelActive(HDC)
end function

Function GetMP3Tag(hdc as long) as string
'
' Capture the 128 bytes of MP3 tag
' HDC is the MP3 handle returned by the LoadMP function
'
GetMP3Tag=BASS_StreamGetTags(hdc,1)
end function

Function LoadSample(Smpfile as string) as long
'
' Load a sample file (wav, ogg, mp3, mp2 or mp1)
'
LoadSample=BASS_SampleLoad(false,Smpfile,0,0,65535,0)
end function

Sub PlaySample(HDC as long,freq as long, vol as long,pan as long,loopmode as integer)
'
' Play a loaded sample
' HDC is the Handle of sample loaded by LoasSample function
' freq is the frequency of the playrate (8000,11000,22000,44000,...)
' vol is the volume value (0(mute) to 100(default))
' pan is the audio panning (-100(left) to 100(right))
' loopmode must be True or False

BASS_SamplePlayEX hdc,0,freq,vol,pan,loopmode

end sub

Sub StopSample(HDC as long)
'
'Stop a sample playing
'
BASS_SampleStop HDC
end sub

Sub CloseSample(HDC as long)
'
'Close a loaded sample
'HDC is the Handle of sample loaded by LoasSample function

BASS_SampleFree HDC
end sub

Sub SetVolumeSample(vol as integer)
'
' Set the sample volume
' HDC is the Handle of sample loaded by LoasSample function
'
BASS_SetVolume -1,vol,-1
end sub
Sub CDInit(drv as string)
'
'Initialize the CD audio Driver
'drv is the CD-Rom unit

BASS_CDInit drv,-1
end sub

Sub CDDoor(mode as integer)
'
' Open/Close the CD Driver's door
' mode is False(close) or True(open)
BASS_CDDoor mode
end sub

Function CDReady() as integer
'
'Return True or False if CD is Ready or not
'
CDReady=BASS_CDInDrive
end function

Function TrackCount() as long
'
'Return the number of tracks into the Current CD
'
TrackCount=BASS_CDGetTracks()
end function

Function TrackLength(track as long) as long
'
'Return the length of a CD's Track
'Track is the number of CD's track
'
TrackLength=BASS_CDGetTrackLength(track)
end function

Function PlayTrack(track as long,loopmode as integer) as long
'
'Play a CD's Track
'
PlayTrack=BASS_CDPlay(track,loopmode,-1)
end function

Function IsCDDrive(drv as string) as integer
'
' Check if the drive selected is a CD Driver
'
if GetDriveType(drv)<>5 then
	IsCDDrive=False
else
	IsCDDRive=true
end if
end function

Function GetCDInfo(id as long) as string
'
' get the CD'id info 
' if must be:
' BASS_CDID_IDENTITY(0) Produces a unique identifier for the audio CD currently in the drive.  
' BASS_CDID_UPC(1) Produces the Universal Product Code (UPC) that is encoded on an audio CD. This might not be available for all CDs.  
' BASS_CDID_CDDB(2) Produces a CDDB identifier. This can be used to get details on the CD's contents from a CDDB server.  
' BASS_CDID_CDDB2(3) Produces a CDDB2 identifier. This can be used to get details on the CD's contents from a CDDB2 server.  

GetCDInfo=BASS_CDGetID(id)
end function

Function GetCDTrackPosition() as long
'
' Playing position into the current CD's Track
'
GetCDTrackPosition=BASS_ChannelGetPosition(0)
end function

Sub SetMP3Position(HDC as long,npos as long)
'
' Set the MP3 position to play
' HDC is a MP3 handle returned by the LoadMP function
' npos is the new position in bytes

BASS_ChannelSetPosition HDC,npos
end sub